/*
 * QtQueryPipe.hpp
 *
 *  Created on: Nov 8, 2010
 *      Author: heber
 */

#ifndef QTQUERYPIPE_HPP_
#define QTQUERYPIPE_HPP_

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif


// All kinds of plumbing for Queries
// Plumbing needs to be outside of the class where it is needed,
// since MOC doesn't like nested classes

#include "Parameters/Parameter.hpp"
#include <Qt/qwidget.h>

#include <vector>

class QLineEdit;
class QListWidget;
class QPushButton;

class QtDialog;

template<typename T> class QtQueryListPipe : public QWidget {
  public:
    QtQueryListPipe(Parameter<std::vector<T> > &_content, QtDialog *_dialog, QLineEdit *_inputBox, QListWidget *_inputList, QPushButton *_AddButton, QPushButton *_RemoveButton);
    virtual ~QtQueryListPipe();

  // Slots to-be.
    virtual void addElement();
    virtual void removeElement();
    virtual void elementSelected();
    virtual void elementEntered(const QString&);

  private:
    void addValue(T item);
    void removeRow(int row);

    Parameter<std::vector<T> > &content;
    QtDialog *dialog;
    QLineEdit *inputBox;
    QListWidget *inputList;
    QPushButton *AddButton;
    QPushButton *RemoveButton;
};

#endif /* QTQUERYPIPE_HPP_ */
